//RandomAgar v1.1
//(c) 2002 Gabriel Nivasch

//Support class for RLE.
//This code is general and can be useful in a lot of cases.
//Feel free to take it.
class RLEdoer
{
	public:
		enum patChar {dead, alive, newline};
		
		RLEdoer()
		{ first=true; line=0; }
		
		void doRLE(patChar inchar, char *outs)
		{
			if (first)
			{
				first=false;
				state=inchar;
				if (inchar==dead || inchar==alive) hcount=1;
				else if (inchar==newline)
				{ vcount=1; hcount=0; }
				sprintf(outs, "");
				return;
			} //if first
			
			if (inchar==dead)
			{
				if (state==dead)
				{ hcount++; sprintf(outs, ""); }
				else if (state==alive)
				{
					if (hcount==1) sprintf(outs, "o");
					else sprintf(outs, "%do", hcount);
					state=dead;
					hcount=1;
				}
				else if (state==newline)
				{ hcount++; sprintf(outs, ""); }
			}
			else if (inchar==alive)
			{
				if (state==dead)
				{
					if (hcount==1) sprintf(outs, "b");
					else sprintf(outs, "%db", hcount);
					state=alive;
					hcount=1;
				}
				else if (state==alive)
				{ hcount++; sprintf(outs, ""); }
				else if (state==newline)
				{
					if (vcount==1) sprintf(outs, "$");
					else sprintf(outs, "%d$", vcount);
					doMaxLine(outs);
					char s2[20]="";
					if (hcount==1) sprintf(s2, "b");
					else if (hcount>1) sprintf(s2, "%db", hcount);
					doMaxLine(s2);
					strcat(outs, s2);
					state=alive;
					hcount=1;
					return; //return immediately in this case
				}
			}
			else if (inchar==newline)
			{
				if (state==dead)
				{
					state=newline;
					hcount=0;
					vcount=1;
					sprintf(outs, "");
				}
				else if (state==alive)
				{
					if (hcount==1) sprintf(outs, "o");
					else sprintf(outs, "%do", hcount);
					state=newline;
					hcount=0;
					vcount=1;
				}
				else if (state==newline)
				{ hcount=0; vcount++; sprintf(outs, ""); }
			}
			
			doMaxLine(outs);
		} //doRLE()
		
		void endRLE(char *outs)
		{
			if (state==alive)
			{
				if (hcount==1) sprintf(outs, "o");
				else sprintf(outs, "%do", hcount);
			}
			else sprintf(outs, "");
			doMaxLine(outs);
			char s2[5]="!";
			doMaxLine(s2);
			strcat(outs, s2);
		} //endRLE()
		
	private:
		patChar state;
		bool first;
		int hcount, vcount, line;
		static const int maxline=70;
		
		void doMaxLine(char *s)
		{
			int len=strlen(s);
			line+=len;
			if (line>maxline)
			{
				char s2[20]="\n";
				strcat(s2, s);
				strcpy(s, s2);
				line=len;
			}
		}
}; //RLEdoer