//RandomAgar v1.1
//(c) 2002 Gabriel Nivasch
#include "symm.h"
#include "field.h"
#include "RLEdoer.h"

template<class Symm> void recoverInitialField(const char *inname, FILE *inf)
{
	Field<Symm> f;
	f.readCompactField(inf);
	
	//Output agar to a file:
	char outname[35];
	strcpy(outname, inname);
	strcat(outname, " initial");
	FILE *outf=fopen(outname, "w");
	assert(outf);
	fprintf(outf, "#C %s\n", outname);
	f.printAgar(outf);
	fclose(outf);
	setCreatorCode(outname);
}

int main()
{
	printf("Enter filename (make sure it has no spaces): ");
	char name[35];
	scanf("%34s", name);
	FILE *f=fopen(name, "r");
	assert(f);
	//Get to second line:
	while (fgetc(f)!='\n') { assert(!feof(f)); }
	char dummy[30];
	fscanf(f, "%s", dummy); //"#C"
	fscanf(f, "%s", dummy); //"Symmetry"
	//Get symmetry number:
	int symmn;
	fscanf(f, "%d", &symmn);
	fscanf(f, "%s", dummy); //"."
	fscanf(f, "%s", dummy); //"Params:"
	//Branch according to symmetry:
	switch(symmn)
	{
		case   1: recoverInitialField<TorusSymm>(name, f); break;
		case   2: recoverInitialField<ClosedPillowcaseSymm>(name, f); break;
		case   3: recoverInitialField<OrthoCylinderSymm>(name, f); break;
		case  -3: recoverInitialField<DiagCylinderSymm>(name, f); break;
		case   4: recoverInitialField<OrthoKleinSymm>(name, f); break;
		case  -4: recoverInitialField<DiagKleinSymm>(name, f); break;
		case   5: recoverInitialField<OrthoRectangleSymm>(name, f); break;
		case  -5: recoverInitialField<DiagRectangleSymm>(name, f); break;
		case   6: recoverInitialField<OrthoOpenPillowcaseSymm>(name, f); break;
		case  -6: recoverInitialField<DiagOpenPillowcaseSymm>(name, f); break;
		case   7: recoverInitialField<OrthoFootballSymm>(name, f); break;
		case  -7: recoverInitialField<DiagFootballSymm>(name, f); break;
		case   8: recoverInitialField<OrthoMobiusSymm>(name, f); break;
		case  -8: recoverInitialField<DiagMobiusSymm>(name, f); break;
		case   9: recoverInitialField<OrthoTurnoverHypoSymm>(name, f); break;
		case  -9: recoverInitialField<DiagTurnoverHypoSymm>(name, f); break;
		case  10: recoverInitialField<TurnoverSymm>(name, f); break;
		case  11: recoverInitialField<OrthoTriangleSymm>(name, f); break;
		case -11: recoverInitialField<DiagTriangleSymm>(name, f); break;
		case  12: recoverInitialField<OrthoTurnoverLegSymm>(name, f); break;
		case -12: recoverInitialField<DiagTurnoverLegSymm>(name, f); break;
		default: assert(0); break;
	}
	fclose(f);
	printf("Done.\n");
}